             .title        "Sunsoft-3 (INES 67) Plugin"

;05/08/07
;BootGod

             ;vectors for standard system calls

send_byte:   .equ 0200h
baton:       .equ 0203h
chk_vram:    .equ 0206h
chk_wram:    .equ 0209h
wr_ppu:      .equ 020ch
read_byte:   .equ 020fh
init_crc:    .equ 0212h
do_crc:      .equ 0215h
finish_crc:  .equ 0218h

crc0:        .equ 0080h
crc1:        .equ 0081h
crc2:        .equ 0082h
crc3:        .equ 0083h

address:       .equ 00e0h
address_lo:    .equ 00e0h
address_hi:    .equ 00e1h
curbank:    .equ 00e2h
banksleft:    .equ 00e3h
bank0crc:  .equ 00e4h

reg:       .equ 00e8h
reg_lo:    .equ 00e8h
reg_hi:    .equ 00e9h

numpages_lo .equ 00eah
numpages_hi .equ 00ebh


temp_crc:    .equ 00ech

;plugin header defines
p_ver: = 1	;plugin version
p_read: = 1	;plugin is for downloading (dumping)
p_write: = 2	;plugin is for uploading (RAM carts / WRAM etc)
p_other: = 3	;plugin is for some other purpose (i.e. BankWatch)
p_var1: = 4	;plugin uses user variable #1
p_var2: = 8	;plugin uses user variable #2
p_var3: = 16	;plugin uses user variable #3
p_var4: = 32	;plugin uses user variable #4

;plugin header data

             .org 0380h
             
             ;plugin description
             .db "Sunsoft-3 Carts"
             .fill 03e0h-*,00h

             ;plugin creator(s)
             .db "BootGod"
             .fill 03f8h-*,00h

             ;PRG/CHR/WRAM min/max sizes supported
             .db 128 >> 4,0 >> 4
             .db 128 >> 3,0 >> 3
             .db 0,0

             ;plugin version and flags
             .db p_ver
             .db p_read

;plugin code start here

             
             lda #4
             jsr send_byte	;mirroring is mapper ctrl


;send PRG size info

got_prg:     lda #0		;send PRG header
             jsr send_byte
             lda #2		;200h pages = 128K
             jsr send_byte
             lda #001h
             jsr send_byte

             lda #0
             sta curbank
             lda #8
             sta banksleft	;8 x 16K

             ldy #0

next_prg:    lda curbank
             sta 0f800h		;write cur bank num

             lda #0
             sta address_lo
             lda #080h
             sta address_hi	;set address to $8000

             ldy #0
             ldx #64		;setup for 16K bank dump

dump_prg:    lda (address),y
             jsr send_byte
             iny
             bne dump_prg
             inc address_hi
             dex
             bne dump_prg
             inc curbank
             dec banksleft
             bne next_prg
             

;send CHR ROM size info
             
got_chr:     
             lda #0
             sta curbank
             lda #64
             sta banksleft	;64 x 2K

             lda #0		;send CHR header 
             jsr send_byte
             lda #2		;200h pages = 128K
             jsr send_byte
             lda #002h
             jsr send_byte
             
next_chr:    lda curbank
             sta 08800h		;select bank at PPU $0000

             lda #0
             jsr wr_ppu
             lda 2007h

             ldx #8		;8 pages = 2K
             ldy #0

dump_chr:    lda 2007h
             jsr send_byte
             iny
             bne dump_chr
             dex
             bne dump_chr
             inc curbank
             dec banksleft
             bne next_chr

finished:    lda #000h		;send termination header
             jsr send_byte
             lda #000h
             jsr send_byte
             lda #000h
             jsr send_byte

             rts

             .fill 0800h-*,0ffh   ;fill rest to get 1K of data

             .end
